#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	Paste In Place
#      By:	sdmitch
#   Usage:	Edit>Paste In Place Copy of Group/Component to Layer
#		 Note:	
#			
#    Date:	
#------------------------------------------------------------------------------------------------
require 'Sketchup'
unless file_loaded?(__FILE__)
	UI.menu("Edit").add_item("Paste In Place Copy of Group/Component to Layer") { SDM::Paste_In_Place.main }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	module Paste_In_Place

		def self.main
			mod = Sketchup.active_model
			ent = mod.active_entities
			sel = mod.selection
			#
			unless sel.empty?
				lay = mod.layers
				nam = lay.map{|l|l.name}
				act = mod.active_layer.name
				val = UI.inputbox(["Paste Copy On Layer:"],[act],[nam.join("|")],"Paste In Place")
				if val
					mod.start_operation "Paste In Place"
					mod.active_layer=val[0]
					g = sel.grep(Sketchup::Group)
					c = sel.grep(Sketchup::ComponentInstance)
					sel.clear; sel.add g; sel.add c
					org = ent.add_group sel; org.name = 'org'; org.layer = 'Layer0'
					new = org.copy; new.name = 'new'; new.layer = mod.active_layer
					new.entities.each{|e| e.layer = mod.active_layer}
					org.explode;new.explode; mod.active_layer=act
					UI.messagebox "paste-in-place Copy on Layer #{val[0].upcase} has been completed"
					mod.commit_operation
				end
			else
				UI.messagebox "Nothing Selected"
			end
			#
		end
	end
end


